#ifndef _RF_H
#define _RF_H

#include "ateams.h" 
/********
 * Restricted Forest Algorithm implementation
 */

typedef struct {
  int a, b;
  float key;
} rf_arest;

typedef struct {
  int x;
  int diff;
  int pt;
  int nsource;
} rf_find_array_type;

typedef struct {
  rf_find_array_type *a;
  int npts;
  int p;
} rf_find_type;

typedef struct {
  rf_find_type *C; /* union find set structure */
  ppc_instance *inst;
  int (*f)();
  int (*g)();  
  rf_arest *ar;
  int *comp; /* component in wich an arest is located */
  int *comp_vert;
  int *index;
  int *pos;
  float *d;
  int nac;    /* number of active components */
  int *td;    /* temporary for destinations */
  int *part_verts; /* verts for use in consensus based  heuristic */
} restricted_forest_tad;

restricted_forest_tad *
rf_create(ppc_instance *inst, int (*f1)());
void rf_delete(restricted_forest_tad *rf);
void rf_exec(restricted_forest_tad *rf, int* LB);
int rf_f();
int rf_g();
int get_verts_from_arests(arest *a, int *verts, int n, int m);
Graph *restricted_forest_withpt(restricted_forest_tad *rf, int *pt, int npts);
int rf_bound(int argc, char **argv);
#endif /* _RF_H */
