#include "pvm3.h"
#include "stdio.h"
#include "stdlib.h"

#define maxcont 20

/* Message Label Type Definition */
typedef enum {
     neigmsg,startup,compmsg,ack,safe,termination
} msglabel_t;

main(){

  int ptid, mytid;
  int end;
  int n;
  int *neig;
  int *delta;
  int i;
  int j;
  int origin, currents, tempo, pulse_origin;
  int expected;
  int cont;
  char ParamFile[80];
  int myend;
  int otherend;

/* Inicialization */
  FILE *outfile;
  char OFName[20];
  int count;

  ptid=pvm_parent();
  mytid=pvm_mytid();
  sprintf(OFName,"sinc/out/p%x.txt",mytid);
  if ((outfile=fopen(OFName,"w"))==NULL)
  {
     printf("Can't open output file\n");
     exit(1);
  }
  cont=1;
  n=0;
  expected=0;
  end=FALSE;

  myend=FALSE;
  
  while (!end)
  {
    int bufid,len,who;
    msglabel_t type;
    div_t rnumb;

    /* Getting a Message */
    bufid=pvm_recv(ptid,-1);
    pvm_bufinfo(bufid,&len,(int *) &type, &who);

    switch(type){

      /* Startup Messages */
      case startup:
          pvm_upkint(&n,1,1);
          otherend=n;
          neig=(int *)calloc(n,sizeof(int));
          delta=(int *)calloc(n,sizeof(int));
          pvm_upkint(neig,n,1);
          pvm_upkint(delta,n,1);
          pvm_upkstr(ParamFile);
          currents=0;
          /* Computation */
          srand(mytid);
          rnumb=div(rand(),n);
          pvm_initsend(PvmDataDefault);
          pvm_pkint(&neig[rnumb.rem],1,1);
          i=currents;
          pvm_pkint (&i,1,1);
          pvm_send(ptid,compmsg);
          expected++;
          break;
      case safe:
          pvm_upkint(&currents,1,1);
          fflush(outfile);
          pvm_upkint(&origin,1,1);
          while (origin > -1)
          {
             pvm_upkint(&pulse_origin,1,1);
             pvm_upkint(&tempo,1,1);
             if (tempo == -2)
             {
                 otherend--;
                 cont=maxcont;
                 fprintf(outfile,"\nFim - %d.\n",origin); 
                 fflush(outfile);
             }
             fprintf(outfile,"Diferenca/ Delta = %d/%d\n",currents-pulse_origin,delta[origin]); 
             if (((currents-pulse_origin) >delta[origin])&&(delta[origin]!=-1))
                 fprintf(outfile,"%x - Erro nos Deltas! meu %d. dele %d. delta %d\n",mytid,currents,tempo,delta[origin]);
             else
                 fprintf(outfile,"Correto\n");
             fflush(outfile);
             pvm_upkint(&origin,1,1); 
             if (origin !=-1)
             {
               fprintf(outfile,"Origin - %d.",origin);
               fflush(outfile);
             } 
          } 
          fprintf(outfile,"\n");
        if (cont <maxcont)
        {
          /* Computation */
          for (i=0;i<6;i++)
          {
            pvm_initsend(PvmDataDefault);
            rnumb=div(rand(),n);
            pvm_pkint(&neig[rnumb.rem],1,1);
            pvm_pkint (&currents,1,1);
            pvm_send(ptid,compmsg);
            expected++;
            fflush(outfile);
          }
          cont++;
        }
        else
        {
             if (!myend)
             {
                 int j;

             fprintf(outfile,"Fim de envio de msg de computacao\n");
             fflush(outfile);
                 j=-2;
                 myend=TRUE;
                 for (i=0;i<n;i++)
                 {
                    pvm_initsend(PvmDataDefault);
                    pvm_pkint(&neig[i],1,1);
                    pvm_pkint (&j,1,1);
                    pvm_send(ptid,compmsg);
                    fprintf(outfile,"Enviando mensagem de Fim para %d\n",i);
                    fflush(outfile);
                 }
             }
             if ((otherend==0)&&(myend))
             {
                    end=TRUE;
                    fprintf(outfile,"Fim de Execucao\n");
                    fflush(outfile);
             }
             else
             {
                    pvm_send(ptid,safe);
             }
         }
         break;
      case ack:
          expected--;
          if (expected==0)
             pvm_send(ptid,safe);
          break;
    } /* switch */
  } /* while*/

/* Fim */
 pvm_initsend(PvmDataDefault);
 pvm_send(ptid,termination);

 free(neig);
 free(delta);
 fclose(outfile);
 pvm_exit();
 exit(0);
}
